#include<iostream>
#include<fstream>
#include<climits>
#include<vector>
#include<string>
#include<algorithm>
#include<sstream>
#include<fstream>
#include<cmath>
#include<list>
#include<map>
#include <boost/iostreams/device/file.hpp>
#include <boost/iostreams/stream.hpp>
#include <boost/iostreams/stream_buffer.hpp>
#define WAITUSER cout << endl << "Press Return";cin.get();
using namespace std;
#define X_CHROMOSOME 1000
#define Y_CHROMOSOME 1001
void terminate(int retval)
{
  cout << endl << "Terminating! because of Error " << retval << endl;
  exit(retval);
}

int checkFile(string fileName)
{
  ifstream fileOpenTest;
  int isFileOpen=-1;
  fileOpenTest.open(fileName.c_str());
  if (fileOpenTest.is_open())
  {
    isFileOpen=1;
    fileOpenTest.close();
  }
  return isFileOpen;
}


unsigned int extract_chrnum(string s_chrNum, bool XY){
  unsigned int len=s_chrNum.size();
  unsigned int count =0;
  unsigned int chrNum=0;
  //cout << endl << "LEN" << len;WAITUSER;
  for (unsigned int n=len; n>0; --n)
  {
    char c = s_chrNum[n-1];
   if (c >= '0' && c<='9'){
      ++count;
      if (count==1)
      {
	chrNum+= (c-'0');
      }
      else if (count==2)
      {
	chrNum+= (c-'0')*10;
      }
      else if (count==3)
      {
	chrNum+= (c-'0')*100;
      }
      else if (count > 3)
	chrNum=0;
    }
    //cout << endl << "char:" << c << " len:" << n << " chrnum" << chrNum;WAITUSER;
  }
    
  if (chrNum==0 && XY==0)
  {
    for (unsigned int n=len; n>0; --n)
    {
      char c = s_chrNum[n-1];
      if (c == 'X' || c== 'V' || c=='I'){
	++count;
	if (count==1)
	{
	  if (c=='X')
	    chrNum+=10;
	  else if (c=='V')
	    chrNum+=5;
	  else if (c=='I')
	    chrNum+=1;
	}
      else if (count>1 && count <=4)
	{
	 // cout << endl << " " << count << " " << char(s_chrNum[n]); WAITUSER;
	  if (c < char(s_chrNum[n])){	  
	    if (c=='X')
	      chrNum-=10;
	    else if (c=='V')
	      chrNum-=5;
	    else if (c=='I')
	      chrNum-=1;
	  }
	  else if (c >= char(s_chrNum[n])){
	    if (c=='X')
	    chrNum+=10;
	  else if (c=='V')
	    chrNum+=5;
	  else if (c=='I')
	    chrNum+=1;
	  }
	}
	else if (count >4)
	  chrNum=0;
      }
    }
    //cout << endl << "Roman Numeral " << chrNum; WAITUSER;
  }
  else if (chrNum==0 && XY==1)//XY chromosome
    for (unsigned int n=len; n>0; --n){
      char c=s_chrNum[n-1];
      if (c=='X')
	chrNum=X_CHROMOSOME;
      else if (c=='Y')
	chrNum=Y_CHROMOSOME;
    }
  return chrNum;
}
